package sun.tracing.dtrace;

import java.util.HashSet;
import java.lang.ref.ReferenceQueue;
import java.lang.ref.WeakReference;

class SystemResource extends WeakReference<Activation>
{
    private long handle;
    private static ReferenceQueue<Activation> referenceQueue;
    static HashSet<SystemResource> resources;
    
    SystemResource(Activation referent, long handle) {
        super(referent, SystemResource.referenceQueue);
        this.handle = handle;
        flush();
        SystemResource.resources.add(this);
    }
    
    void dispose() {
        JVM.dispose(this.handle);
        SystemResource.resources.remove(this);
        this.handle = 0L;
    }
    
    static void flush() {
        SystemResource systemResource;
        while ((systemResource = (SystemResource)SystemResource.referenceQueue.poll()) != null) {
            if (systemResource.handle == 0L) {
                continue;
            }
            systemResource.dispose();
        }
    }
    
    static {
        SystemResource.referenceQueue = (SystemResource.referenceQueue = new ReferenceQueue());
        SystemResource.resources = new HashSet();
    }
}
